package com.example.zxa01.iotclient.component.detail;

import com.example.zxa01.iotclient.R;
import com.example.zxa01.iotclient.common.http.DownloadTask;
import com.example.zxa01.iotclient.common.pojo.device.Device;
import com.example.zxa01.iotclient.component.privacy.PrivacyActivity;
import android.arch.lifecycle.MutableLiveData;
import android.arch.lifecycle.ViewModel;
import android.content.Context;
import android.content.Intent;
import android.databinding.ObservableBoolean;
import android.databinding.ObservableField;
import android.os.AsyncTask;
import android.os.Environment;
import android.support.annotation.NonNull;
import android.util.Log;
import android.view.Gravity;
import android.widget.Toast;

import java.io.BufferedInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;

public class DetailViewModel extends ViewModel {

    public ObservableBoolean isLoading = new ObservableBoolean(true);
    public ObservableField<Device> device = new ObservableField<>();
    private DetailModel detailModel = new DetailModel();
    private Context context;
    private Toast toast;


    public DetailViewModel(Context context) {
        this.context = context;
        device.set(new Device());
    }

    public void fetchDevice(@NonNull String udn) {
        detailModel.readDevice(udn);
    }

    public MutableLiveData<Device> observeDeviceMLD() {
        return detailModel.getDeviceMLD();
    }

    public void setDevice(@NonNull Device device) {
        if (device.getUdn() != null) {
            isLoading.set(false);
            this.device.set(device);
        }
    }

    public void settingPrivacy() {
        context.startActivity(
                new Intent(context, PrivacyActivity.class)
                        .putExtra("udn", device.get().getUdn()));
    }

    public void downloadPrivacyReport() {
        // fake file just for test
        String url = "https://www.ey.gov.tw/File/4EBD1D15E6556A04?A=C";
        new DownloadTask(context, url);
    }
}
